<template src="./template.html"></template>

<script lang="ts">
import { cloneDeep } from "lodash";
import { Component, Vue, Watch } from "nuxt-property-decorator";
import { apiErrorHandler } from "~/utils/apiHanlers";
var momentz = require("moment-timezone");
@Component({
  components: {
    Twofa: () => import("@/components/Utils/Twofa/index.vue"),
  },
})
export default class SellerSettingsBasicInfoComponent extends Vue {
  listMode = [
    { name: "UTC -8(US)", value: "sandbox" },
    { name: "UTC -7(VN)", value: "live" },
  ];
  payment = {
    mode: "sandbox",
  };
  passwordOld = "";
  passwordNew = "";
  rePasswordNew = "";
  isHidePassword = false;
  isHidePasswordNew = false;
  isHideRePasswordNew = false;

  loading = false;
  loadingPassword = false;

  user = {
    email: "",
    name: "",
    phoneNumber: "",
  };

  mounted() {
    this.onSetUser();
  }

  onSetUser() {
    const userInfo = cloneDeep(this.$store.state.user?.userInfo || {});
    if (userInfo) {
      this.user.email = userInfo.email || "";
      this.user.name = userInfo.name || "";
      this.user.phoneNumber = userInfo.phoneNumber || "";
    }
  }

  async onUpdateInfo() {
    try {
      this.loading = true;
      await this.$api.user.updateInfo(this.user);
      this.$store.dispatch("user/onGetMe", { ctx: this });
      this.$pushNotification.success("Update info successfully");
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  async changePassword() {
    try {
      if (!(this.passwordOld && this.passwordNew && this.rePasswordNew)) {
        return this.$pushNotification.error("Please enter all information");
      } else if (this.passwordNew.length < 6) {
        return this.$pushNotification.error("Password must be 6 characters");
      } else if (this.passwordNew !== this.rePasswordNew) {
        return this.$pushNotification.error("Two passwords do not match");
      }
      this.loadingPassword = true;
      const body = {
        password: this.passwordOld,
        newPassword: this.passwordNew,
        passwordConfirm: this.rePasswordNew,
      };
      await this.$api.user.changePassword(body);
      this.$pushNotification.success("Change password successfully");
      this.passwordOld = "";
      this.passwordNew = "";
      this.rePasswordNew = "";
      this.$store.dispatch("user/onGetMe", { ctx: this });
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingPassword = false;
    }
  }
}
</script>
